@echo off
goto begin

Program   : ADDSIG.BAT
Purpose   : Add a signature file to the file specified in the parameter
Date      : July 19. 1994
Modified  : August 11, 1994 - Added visual progress indicator for signature
                              search
            960228 - Changed location of Signature file to
                     c:\comm\pegasus\pmail\%USR%\INETSIG.PMS for
                     compatibility with Pegasus


Parameters: %1 = Preferred Word Processor or Text Editor
            %2 = Reply File


Variables : CHKLINE      = The second line of the Signature File, used for
                           comparison to see if the Signature File has
                           already been added to the Reply File (the second
                           line of the Signature File is used since the
                           first line is expected to be a CRLF and nothing
                           else)

            TOTAL_LINES  = The number of lines in the Reply File

            LINECOUNT    = The number of lines in the Reply File, used for
                           iterations in searching for CHKLINE
            
            GAS_GAUGE    = Visual indicator of progress (40 x ASCII 178 "")

            GAUGE_SIZE   = Number of characters in GAS_GAUGE to display

            SIGFILE      = Fully qualified path to Signature File

Temp Files: FINDLINE.$$$ = Redirected output from FIND to determine the
                           number of lines in the Reply File

            ADDSIG.$$$   = Temporary file used to concatenate the Signature
                           File to the Reply File

:begin
rem Speed things up if we are running NDOS
if "%@eval[2+2]"=="4" loadbtm on

set sigfile=c:\comm\pegasus\pmail\%USR%\inetsig.pms

if "%1"==""   goto help
if "%1"=="?"  goto help
if "%1"=="/?" goto help
if "%1"=="/h" goto help
if "%1"=="/H" goto help

rem The editor name is optional, but must go in the first parameter position
if "%2"=="" goto no_editor
set editor=%1
shift
goto past_editor

:no_editor
set editor=qw

:past_editor
rem The whole exercise is pointless if there is no Signature File
if not exist %sigfile% goto do_edit

rem Only perform the check if the Reply File already exists
if exist %1 goto check_signature

rem If there is not Reply File copy the Signature File and just edit it
copy %sigfile% %1 > nul
goto do_edit

rem The fancy stuff for signature checking can only be done with NDOS
rem If we're running COMMAND.COM we just add the Signature File regardless
:check_signature
if not "%@eval[2+2]"=="4" goto add_signature

rem Find out what it is we are checking for
set chkline=%@line[%sigfile%,1]

rem Find the number of lines in the reply file
find /c/v "" < %1 > %temp%\findline.$$$
set total_lines=%@line[%temp%\findline.$$$,0]
set linecount=%total_lines%

del %temp%\findline.$$$ > nul

rem Build Gas Gauge border
cls
be window 10 17 14 62 bright white on blue
be rowcol 11 19 "Checking Reply File for Existing Signature"
be rowcol 13 20 ""

rem Check to see if the signature already exists in this file by comparing
rem each line to the check line, and display progress visually
:check_again
rem Display Gas Gauge
set gauge_size=%@eval[40-((40*(%linecount%-1))/%total_lines%)]
set gas_gauge=%@substr[,0,%gauge_size%]
be rowcol 13 20 "%gas_gauge%" bright yellow on blue

rem Hide any error messages caused by quotes in compared text
echo [0;0H[0;8m
                         
if "%@line[%1,%linecount%]"=="%chkline%" goto do_edit
set linecount=%@eval[%linecount%-1]
if %linecount% GT 0 goto check_again

unset linecount, chkline, gauge_size, gas_gauge, total_lines

rem Simulate PINE:  Add signature before editing
:add_signature
copy %1 + %sigfile% %temp%\ADDSIG.$$$ > nul

copy %temp%\ADDSIG.$$$ %1 > nul
del %temp%\ADDSIG.$$$ > nul

:do_edit
echo [0m
call %editor% %1

rem Clean up
unset editor
goto end

:help
echo.
echo Usage:  ADDSIG [editorname] replyfilename
echo.
echo ADDSIG will check for the existence of a Signature File
echo and append it to the specified Reply File.
echo When running NDOS if the Signature File already exists within the
echo Reply File it is not added again.
echo.
echo If the Editor Name is omitted then the QW editor is assumed.
echo.
echo Looking for signature file "%sigfile%"
echo.

:end

unset sigfile

rem EOF: ADDSIG.BAT

