@echo off
goto begin

Program   : ADDSIGP.BAT
Purpose   : Strip PGP signature, edit, Add a PGP signature to the file
Date      : 960616

Note      : This file must be called *.BAT (not *.BTM) to be recognized by SLMR

Parameters: %1 = Preferred Word Processor or Text Editor
            %2 = Reply File

Variables : TEXTFILE = Reply File name passed as a parameter
            TEXTNAME = The filename portion of TEXTFILE

Files     : TEXTFILE     = The reply file passed to ADDSIGP and returned
            TEXTNAME.    = The stripped file created by PGP (temp)
            TEXTNAME.asc = ASCII-armored signed file created by PGP (temp)


:begin
rem Speed things up if we are running NDOS
if "%@eval[2+2]"=="4" loadbtm on

if "%1"==""   goto help
if "%1"=="?"  goto help
if "%1"=="/?" goto help
if "%1"=="/h" goto help
if "%1"=="/H" goto help

rem The editor name is optional, but must go in the first parameter position
iff "%2" == "" then
    set textfile=%1
else
    set textfile=%2
endiff

set textname=%@name[%TEXTFILE%]

if not exist %TEXTFILE% goto nofile

rem Check for and strip existing signature (creates TEXTNAME with no
rem       extension), force overwrite of existing file
pgp +force %TEXTFILE%

rem If TEXTFILE has no extension then the files don't need to be renamed
iff "%textfile%" NE "%textname%" then
    del /q %TEXTFILE%
    ren /q %TEXTNAME% %TEXTFILE%
endiff

:nofile
call addsig %&

cls

rem Include PGP signing (this creates %TEXTNAME%.asc), force overwrites
pgp -s +force %TEXTFILE% -u %usr%

del /q %TEXTFILE%
ren /q %TEXTNAME%.asc %TEXTFILE%

rem Clean up
unset textname textfile
goto end

:help
echo.
echo Usage:  ADDSIGP [editorname] replyfilename
echo.
echo ADDSIGP will strip off any existing PGP signature, use ADDSIG to edit
echo the file, then attach a new PGP signature.
echo.
echo ADDSIG will check for the existence of a Signature File
echo (H:\CONFIG\SIGNATUR.TXT) and append it to the specified Reply File.
echo When running NDOS if the Signature File already exists within the
echo Reply File it is not added again.
echo.
echo If the Editor Name is omitted then the QW editor is assumed.
echo.

:end

rem EOF: ADDSIGP.BAT

