@echo off
goto begin

Program   : LOGIN.BAT
Purpose   : Login to network, set system settings
Date      : 12 Sep 1998
Author    : Bob Jonkman
Notes     : DR-DOS and PNW don't support system login scripts, so this
            takes its place
Modified  : 981008 - Added checks and calls for workstation and user login
            continuations
            981010 - v1.1: added error checking
            981013 - v1.1a: Check for no full name in PMAIL.USR
            981219 - v1.1b: Removed 'Screen Attributes' command (BE SA)

Parameters: %1 - login name

Variables : ERR_LOGIN - Error message set on error (sticky)
            LOGIN_ID  - Login name

:begin
set ver_login=LOGIN.BAT v1.1b (981219)

echo [0;1;37;46m[2J
rem be sa bright white on cyan /n
cls
be window  0  0  2  79 bright white on cyan
be rowcol  1  1  " Login to DR-DOS Network                                                      " bright black on white
be rowcol  1  %@eval[78-%@len[%ver_login%]] "%ver_login%" bright black on white
be rowcol 4 0

set err_login=
if "%pmpath%"=="" set pmpath=m:

rem Ensure that all logout continuations are performed
call logout

set login_id=%1
if not "%login_id%"=="" goto dologin

input Type your username: %%login_id

:dologin
net login workgroup/%login_id%
if errorlevel 1 goto err_login

rem This is expected to have an error, so don't check
net map e: cdrom

rem Errors on drive mappings should not be fatal
net map f: cdrive asimov_pc
if errorlevel 1 set err_login=Warning: drive F: is not mapped

net map g: cdrive bradbury_pc
if errorlevel 1 set err_login=Warning: drive G: is not mapped

net map h: u_%login_id%
if errorlevel 1 set err_login=Warning: drive H: is not mapped

net map i: apps
if errorlevel 1 set err_login=Warning: drive I: is not mapped

net map m: mail
if errorlevel 1 set err_login=Warning: drive M: is not mapped

net capture lpt1 epson-lx80
if errorlevel 1 set err_login=Warning: Printer is not captured


net time

rem Login successful!
set usr=%@upper[%login_id%]

rem =================================================================
rem Extract full name from PMAIL.USR file
rem =================================================================
rem Find line with user name, put into variable USRLINE
find /i ";%usr%;" < %pmpath%\pmail.usr > %temp%\findline.$$$

rem If the name isn't found FINDLINE.$$$ is empty (0 bytes)
if "%@filesize[%temp%\findline.$$$]" gt "0" goto set_usrfull

set usrfull=-Unknown Name-
goto set_prompt

:set_usrfull
set usrline=%@line[%temp%\findline.$$$,0]

rem Remove user type (A; or U;) from user line
set usrline=%@substr[%usrline%,2,%@len[%usrline%]]

rem Find semicolon
set indxsemi=%@index[%usrline%,;]
set usrfull=%@substr[%usrline%,%@eval[%indxsemi%+1],%@len[%usrline%]]

set indxsemi=
set usrline=
del %temp%\findline.$$$ > nul

:set_prompt
set prompt=$e[1;37;47m Configuration: %boot% $e[45m User: %usrfull% (%usr%) $e[40m$_$E[43m $T  $D $E[44m Shell: $Z $E[40m$_$_$E[42m $P$G $E[40m

if "%err_login%"==""  goto tidy_up
goto err_message

:err_login
set err_login=You are not logged in -- Bad password? Wrong name?
set prompt=$e[1;37;47m Configuration: %boot% $e[46m Not Logged In $e[40m$_$E[43m $T  $D $E[44m Shell: $Z $E[40m$_$_$E[42m $P$G $E[40m

:err_message
echo [0;1;37;41m LOGIN Error: %err_login% [0m

:tidy_up
unset login_id ver_login >& nul

rem Run User, Workstation login continuations
if exist h:\config\logcont.bat call h:\config\logcont.bat
if exist c:\logcont.bat        call c:\config\logcont.bat

:end

rem EOF: LOGIN.BAT

