@echo off
rem SWITCH.BAT   Modified  Dec 7/90, Jan 4/92, Feb 3/92, Apr 22/92
rem A batch file by Spencer Ramshaw to switch around config files.
rem Foolproofed slightly by Bob Jonkman, entirely without permission.
rem Modfied 940520 - Modularized error display code

if "%@eval[2+2]"=="4" loadbtm on

set err_switch=

if "%1"==""  goto help
if "%1"=="?" goto help

if "%2"=="noreset"  set noreset=Y
if "%2"=="NORESET"  set noreset=Y

if "%1"=="previous" goto previous
if "%1"=="PREVIOUS" goto previous

if not exist c:\boot\autoexec.%1 goto nofiles
if not exist c:\boot\config.%1   goto nofiles

c:
cd\
if exist c:\autoexec.$$$ del c:\autoexec.$$$ > nul:
if exist c:\config.$$$   del c:\config.$$$   > nul:

if exist c:\autoexec.bat ren  c:\autoexec.bat autoexec.$$$ > nul:
if exist c:\config.sys   ren  c:\config.sys   config.$$$   > nul:

if exist c:\boot\autoexec.%1  copy c:\boot\autoexec.%1  c:\autoexec.bat > nul:
if exist c:\boot\config.%1    copy c:\boot\config.%1    c:\config.sys   > nul:

if not exist c:\autoexec.bat goto error
if not exist c:\config.sys   goto error
goto boot

rem switch back to the previous configuration
:previous
if not exist c:\config.$$$ goto filegone
if not exist c:\autoexec.$$$ goto filegone

rem swap AUTOEXEC.BAT with AUTOEXEC.$$$
if exist c:\autoexec.$$1 del c:\autoexec.$$1 > con
if exist c:\autoexec.bat ren c:\autoexec.bat autoexec.$$1 > con
ren c:\autoexec.$$$ autoexec.bat > con
ren c:\autoexec.$$1 autoexec.$$$ > con

rem swap CONFIG.SYS with CONFIG.$$$
if exist c:\config.$$1 del c:\config.$$1 > con
if exist c:\config.sys ren c:\config.sys config.$$1 > con
ren c:\config.$$$ config.sys > con
ren c:\config.$$1 config.$$$ > con

:boot
if "%noreset%"=="Y" goto noreset
call c:\batch\reset

set err_switch=Files have been copied, machine will not re-boot!
goto disp_err

:nofiles
set err_switch=Alternate file(s) missing:  *.%1
goto disp_err

:filegone
set err_switch=Previous files not present:  C:\*.$$$
goto disp_err

:noreset
set err_switch=Files have been copied, but NORESET was specified.
goto disp_err

:error
set err_switch=Files not copied!
goto disp_err

:disp_err
echo.
echo [0;1;37;41m %0 Error:  %err_switch% [0m
echo.
pause
goto end

:help
echo.
echo Usage: SWITCH {alternate_extension} [NORESET]
echo        SWITCH PREVIOUS [NORESET]
echo.
echo AUTOEXEC.BAT and CONFIG.SYS are copied to AUTOEXEC.$$$ and CONFIG.$$$.
echo Then, AUTOEXEC.BAT and CONFIG.SYS are replaced by files of the same 
echo name in the BOOT subdirectory, but the alternate extension provided as 
echo the parameter. If AUTOEXEC.xxx or CONFIG.xxx don't exist, the files 
echo will not be copied, and an error message is  issued.
echo.
echo Note that when successful, the system is re-started to bring the new
echo AUTOEXEC.BAT and CONFIG.SYS files into effect.  Make sure you save any 
echo RAMdisks before using SWITCH!
echo.
echo SWITCH PREVIOUS is used when the configuration existing immediately prior
echo to the last SWITCH command is to be restored.  Consecutive SWITCH PREVIOUS
echo commands will toggle between the two latest configurations.
echo.
echo Specifying "NORESET" as the second parameter will copy the files, but
echo a warmboot will not be performed.
echo.

goto end

:end
set noreset=

rem EOF:SWITCH.BAT

