@echo off
goto begin

Program   : SY.BAT
Purpose   : startup file for Lotus Symphony
Syntax    : SY [drivername] [-A application]

Variables : DRIVER    = name of driver set
            APP       = name of application to load
            OLDPATH   = Temporary storage for PATH
            OLDPROMPT = Temporary storage for PROMPT


Modified 921108WLJ - for use with USER names
                   - Set default SET file to COMBINED
                   - Simplified startup syntax
                   - Added help text
                   - Added checks for USER variable

:begin
if "%@eval[2+2]"=="4" loadbtm on

if "%1"=="/h" goto help
if "%1"=="/H" goto help
if "%1"=="?"  goto help
if "%1"=="/?" goto help

rem Check to see if Symphony has been configured for this user, update and
rem       add drivers if not
if not exist h:\config\symphony\nul md h:\config\symphony
replace c:\symphony\*.set h:\config\symphony /a > nul
replace c:\symphony\*.cnf h:\config\symphony /a > nul
replace c:\symphony\*.set h:\config\symphony /u > nul
replace c:\symphony\*.cnf h:\config\symphony /u > nul

rem Change to Symphony configuration directory, disabling NCD alias.
rem Note: Symphony claims to be uninstalled if not executed with CWD on Drive C:
pushdir
c:
pushdir
*cd \usr\%usr%\config\symphony

rem If the first parameter is "-A" then no driver set is specified
if "%1"=="-a" goto doapp1
if "%1"=="-A" goto doapp1

rem If the first parameter is not "-A" then set driver set to parameter
set driver=%1

rem Check to see if the second parameter specifies an application
if "%2"=="-a" goto doapp2
if "%2"=="-A" goto doapp2

rem Else no application has been specified
goto cont1

rem First parameter was "-A"
:doapp1
set app=-a %2
goto cont1

rem Second parameter was "-A"
:doapp2
set app=-a %3

:cont1
if "%driver%"=="" set driver=combined

set oldpath=%path%
set path=c:\symphony;%oldpath%
set oldprompt=%prompt%
set prompt=Called from Symphony$_%oldprompt%

rem We no longer use the funny mouse driver...
rem c:\mouse\menu c:\mouse\menu\symphony
c:\symphony\symphony %driver% %app%

set path=%oldpath%
set prompt=%oldprompt%

rem Redirect STDERR to NUL in case some variables don't exist
unset oldpath oldprompt driver app >& nul

rem c:\mouse\menu c:\mouse\menu\standard
popdir
popdir

goto end

:help
echo.
echo Usage:  SY [driverset] [-A application]
echo.
echo This program starts up Lotus Symphony. An optional driver set may be
echo specified:  COMBINED (default) or HIRES.  The COMBINED set allows
echo text and graphics on the same screen, and the HIRES set allows a
echo spreadsheet display of 132 x 43 characters.

echo.
echo An optional application can be specified after a "-A" parameter.  This
echo will attach and invoke on startup.
echo.


:end

rem EOF: SY.BAT

