@echo off
goto begin

Program     : USER.BAT
Purpose     : Selects the current user directory
Date        : October 11, 1994
Author      : Bob Jonkman <bjonkman@sobac.com>
Organization: SOBAC Microcomputer Services
CoPyRiGhT=Copyright (c) 1998 SOBAC Microcomputer Services as an unpublished work
                                                                               .
Modified    : 951231 - Heavy changes for full-screen interactivity
              970127 - Added check for login and logout routine
              971114 - Extract %FULL_NAME% from PMAIL.USR file
              980509 - Added NET LOGON/LOGOFF command for network
                       (removed due to memory constraints - WFW must now run
                       for sharing to be active)
              980510 - Added Username insertion into SYSTEM.INI and PMAIL.INI
              980630 - Added idle timeout to run Distributed.Net RC5
              980913 - Replaced SUBST with LOGIN commands for DR-DOS
                     - Made other changes to enable PNW network
              980927 - Changed paths for server drives (MAIL=M:, APPS=I:)
              981007 - Incremented version to 2.3
                     - Added vector to idle process through C:\IDLE.BAT
                     - Moved call to user LOGIN/LOGOUT.BAT into system
                       LOGIN/LOGOUT.BAT; moved SET USR and SET USRFULL
                       to LOGIN.BAT
              981012 - Version 2.4: Propagate LOGIN.BAT error to
                       fullscreen, added BOX_X1 and BOX_X2 variables to
                       position LOGIN.BAT error message ERR_LOGIN
              981103 - Fixed repeat login -- now avoids LOGIN.BAT on repeat
              981115 - v2.4d: fixed box size error
              981122 - v2.5: Added progress for application configuration
                     - Erasing USR and USRFULL on LOGIN error or warning
              990131 - Added LMOUSE environment variable to Windows config

:begin
rem When this file is a .BTM file it cannot be processed by QEMM's Optimize
if "%@eval[2+2]"=="4" loadbtm on

if "%@upper[%1]"=="/H" goto help
if "%1"=="/?" goto help
if "%1"=="?" goto help

:start
set VeRsIoN=USER.BAT V2.5 (981122)
                                                                              :
                                                                              :
set full_screen=
set pmpath=m:
set box_x1=20
set box_x2=59

iff "%1" == "" then        gosub get_input
else
    set newusr=%1
endiff

c:

:process_input
rem  forcing lower case & truncating to 8 characters
set newusr=%@substr[%@lower[%newusr%],0,8]

rem Truncate at the first space
iff %@index[%newusr%, ] NE -1 then
    set newusr=%@substr[%newusr%,0,%@index[%newusr%, ]]
endiff

rem Login!!
cls

rem If already logged in don't do it again
if "%newusr%"=="%usr%" goto dir_exist

rem The login process erases the full screen
set full_screen=
call login %newusr%

rem LOGIN.BAT returns %ERR_LOGIN% on failure; sets USR and USRFULL on success
if "%err_login%"=="" goto dir_exist

rem There has been an error during login...
set new_x1=%@eval[38-%@len[%err_login%]/2]
set new_x2=%@eval[%new_x1%+%@len[%err_login%]+4]
if %new_x1% lt %box_x1% set box_x1=%new_x1%
if %new_x2% gt %box_x2% set box_x2=%new_x2%

rem Delete USR and USRFULL when LOGIN returns an error or warning
set usr=
set usrfull=

gosub draw_screen

be window 08 %box_x1% 15 %box_x2% bright white on red shadow
be rowcol  9 %@eval[29-%@len[%newusr%]/2] "Error logging in '%@upper[%newusr%]':" bright yellow on red
be rowcol 10 %@eval[%new_x1%+2] "%err_login%" bright white on red
be rowcol 12 24 "Contact the Network Adminstrator" bright white on red
be rowcol 13 29 "to create a new User ID" bright white on red
be rowcol 14 26 " Press [ENTER] to continue] " bright white on black
inkey %%scratch

rem Accept interactive input & try again
gosub get_input
goto process_input

:dir_exist

rem ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
rem I                                                                I
rem I       Application Configuration                                I
rem I                                                                I
rem ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

rem =================================================================
rem System files
echo [2J[0;1;37;44m Configuring System ... [0;8m
if not isdir h:\config md h:\config

if not isdir c:\batch md c:\batch
replace g:\batch\*.* c:\batch /u > nul
replace g:\batch\*.* c:\batch /a > nul

if not isdir c:\utility          md c:\utility
if not isdir c:\utility\frequent md c:\utility\frequent
replace g:\utility\frequent\*.* c:\utility\frequent /u > nul
replace g:\utility\frequent\*.* c:\utility\frequent /a > nul

if not isdir c:\utility\files    md c:\utility\files
replace g:\utility\files\*.* c:\utility\files /u > nul
replace g:\utility\files\*.* c:\utility\files /a > nul

if not isdir c:\utility\fprot    md c:\utility\fprot
replace g:\utility\fprot\*.* c:\utility\fprot /u > nul
replace g:\utility\fprot\*.* c:\utility\fprot /a > nul


rem End System Files
rem =================================================================
echo [2J[0;1;37;44m Configuring Windows ... [0;8m
rem Windows

if not isdir h:\config\windows md h:\config\windows
replace i:\windows\user\*.* h:\config\windows\ /u > nul
replace i:\windows\user\*.* h:\config\windows\ /a > nul

change h:\config\windows\system.ini "UserName=UserName" "UserName=%usr%" > nul
change h:\config\windows\system.ini "Comment=Comment"   "Comment=%usrfull%" >nul

rem Search for "h:\config\windows" in search path, add if not found
if %@index[%PATH%,H:\CONFIG\WINDOWS] EQ -1 path h:\config\windows;%path%

rem Move Mouse config file pointer from MOUSE directory to personal directory
SET LMOUSE=H:\CONFIG\WINDOWS

rem End App Conf: Windows
rem =================================================================
echo [2J[0;1;37;44m Configuring Pegasus ... [0;8m
rem  Pegasus

if not isdir %pmpath%\%usr% md %pmpath%\%usr%
iff not exist %pmpath%\%usr%\pmail.ini then
   copy i:\pegasus\pmdflts.ini %pmpath%\%usr%\pmail.ini > nul
   change %pmpath%\%usr%\pmail.ini "PersonalName" "%usrfull%" > nul
endiff

rem End App Conf: Pegasus
rem =================================================================
rem PGP
echo [2J[0;1;37;44m Configuring PGP ... [0;8m

if not isdir h:\config\pgp md h:\config\pgp
if not exist h:\config\pgp\pgp.ini copy i:\pgp\pgp.ini h:\config\pgp > nul

rem End App Conf: PGP
rem =================================================================
rem Netscape
echo [2J[0;1;37;44m Configuring Netscape ... [0;8m

if not isdir h:\config\netscape              md h:\config\netscape
if not isdir h:\config\netscape\mail         md h:\config\netscape\mail
if not exist h:\config\netscape\bookmark.htm copy i:\netscape\bookmark.htm h:\config\netscape > nul

iff not exist h:\config\windows\netscape.ini then
   copy i:\netscape\netscape.ini h:\config\windows > nul
   change h:\config\windows\netscape.ini "User_Addr=User_Addr" "User_Addr=%usr%@sobac.com" > nul
   change h:\config\windows\netscape.ini "User_Name=User_Name" "User_Addr=%usrfull%" > nul
   change h:\config\windows\netscape.ini "Author=Author" "Author=%usrfull%" > nul
endiff

rem End App Conf: Netscape
rem =================================================================
rem WordPerfect & Quinion's Spell Checker
echo [2J[0;1;37;44m Configuring WordPerfect and Quinion's Spell Checker ... [0;8m

if not isdir h:\config\wp md h:\config\wp

rem End App Conf: WP and QSC
rem =================================================================
rem WinFax
echo [2J[0;1;37;44m Configuring Winfax ... [0;8m

if not isdir h:\config\winfax md h:\config\winfax
replace i:\winfax\data\*.* H:\config\winfax /u > nul
replace i:\winfax\data\*.* H:\config\winfax /a > nul


rem End App Conf: WinFax
rem =================================================================
                            
rem ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
rem I End:  Application Configuration                                I
rem ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
echo [0m[2J

rem =================================================================
rem Setting CWD to H:
h:
gosub tidy_up

rem Chaining to GEN_MENU.BAT (which checks for personal menus)
c:\batch\gen_menu

rem Just in case GEN_MENU fails...
quit

:nouser
gosub tidy_up
quit

- - ----------------------------------------------------------
rem Subroutine to blank out centre windows
:blank
be window 2  1 22 78 cyan on cyan
return


- - ----------------------------------------------------------
:get_input
gosub draw_screen
be window 08 %box_x1% 15 %box_x2% bright white on blue shadow
be rowcol 10 30 "Enter Your User Name"
be rowcol 12 35 "          " bright white on black

:get_again
be rowcol 12 36

rem Checking for elapsed time
timer > %temp%\timefile.$$$

rem If timer wasn't turned on, then turn it on
if "%@substr[%@line[%temp%\timefile.$$$,0],0,8]" ne "Timer on" timer > nul

rem Timeout after 65 seconds
input /w65 %%newusr

rem Calculate elapsed time (greater than 1 minute)
timer > %temp%\timefile.$$$
if "%@substr[%@line[%temp%\timefile.$$$,0],6,-1]" ne "1" goto blankinput

rem Timeout was greater than 1 minute, vector to this workstation's idle process
rem If IDLE.BAT doesn't exist then drop through to get_input again
if exist c:\idle.b* call c:\idle

rem Idle process may erase full screen
set full_screen=
goto get_input

rem Check if ENTER was pressed on a blank field
:blankinput
if "%newusr%"=="" set newusr=%usr%
if "%newusr%"=="" goto get_again

return

- - ----------------------------------------------------------
:draw_screen
iff not "%full_screen%"=="Yes" then
     cls
     be window  0  0  24 79 bright white on cyan
     be rowcol  1  1  " User Name Input Routine                                                      " bright black on white
     be rowcol  1  %@eval[78-%@len[%version%]] "%version%" bright black on white
rem     be rowcol  5 20  "It is now safe to turn off your computer" yellow

     iff not "%usr%"=="" then
         be window 18 %box_x1% 20 %box_x2% bright white on green shadow
         be rowcol 19 %@eval[29-%@len[%usr%]/2] "Current User Name:  %@upper[%USR%]"
     endiff

     set full_screen=Yes
endiff

return

- - ----------------------------------------------------------
:tidy_up
iff "%full_screen%"=="Yes" then
    cls
    be sa white on black
endiff

if exist %temp%\findline.$$ del %temp%\findline.$$$ > nul

rem Pipe STDERR to NUL in case some of these variables do not exist
unset pmpath version full_screen newusr scratch box_x1 box_x2 new_x1 new_x2 >& nul
return

- - ----------------------------------------------------------
:help
text

No help available yet

endtext

:end

rem EOF: USER.BAT
