@echo off
goto begin

Program   : ZIP.BAT
Purpose   : Executable Extension command file for ZIPfiles
            Based on the OPEN file for XTGOLD v1.43      900426WLJ
Author    : Bob Jonkman
Date      : February 21, 1992

Parameters: %1 - Name of ZIPfile

Variables : VERSION - Current version number of this utility (local)

Modified  : 920523WLJ - ??
            940119WLJ - Check for NDOS, load if necessary

:begin
if %@eval[2+2]==4 goto ndos_loaded

rem echo Loading alternate command processor
c:\utility\norton\ndos /e+512 /cf:\utility\xtnet\zip %1 %2 %3 %4 %5 %6 %7 %8 %9
rem echo Returning to default command processor

goto end

:ndos_loaded
loadbtm on
cls
be sa bright white on blue /n
be window  0  0  24 79 bright white on cyan explode

set version=V1.1 (940119)
set zipname=%@name[%1]

:start
be rowcol  1  1  " ZIPfile Manager by Bob Jonkman                                               " bright black on white
be rowcol  1  %@eval[78-%@len[%version%]] "%version%" bright black on white

rem Display current directory in "Filename Truncation" mode
:diragain


be rowcol 23  1  " Current Directory:                                                           " bright black on white
iff %@len[%_cwd%] GT %@eval[36-%@len[%zipname%]] then
    be rowcol 23 22  "%@substr[%_CWD%,0,3]...%@substr[%_CWD%,%@eval[29-%@len[%zipname%]],%@eval[%@len[%zipname%]-30]]" bright yellow on white
else
    be rowcol 23 22  "%_CWD%" bright yellow on white
endiff

be rowcol 23 %@eval[60-%@len[%zipname%]] "Current ZIPfile:" bright black on white
be rowcol 23 %@eval[78-%@len[%zipname%]] "%zipname%" bright yellow on white

:redisplay
be window  3 10 15 69 bright white on green shadow
be rowcol  5 36 "Main Menu" bright yellow on green
be rowcol  7 15 "  V - View ZIPfile using LIST (Default)" bright white on green
be rowcol  8 15 "  X - Extract ZIPfile" bright white on green
be rowcol  9 15 "  T - Test ZIPfile Integrity" bright white on green
be rowcol 10 15 "  F - Fix ZIPfile using PKZIPFix" bright white on green
be rowcol 11 15 "  C - Change Current Directory"
be rowcol 12 15 "  Q - Quit ZIPFile Manager" bright white on green

be window 18 10 20 69 bright white on blue shadow
be rowcol 19 15
be ask "Selection:  " vxtfcq DEFAULT=v
if errorlevel 6 goto quit
if errorlevel 5 goto change
if errorlevel 4 goto fix
if errorlevel 3 goto test
if errorlevel 2 goto extract
if errorlevel 1 goto view
goto error

:view
keystack "v"
list %1 /d
goto restart

:extract
be window  3 10 15 69 bright white on green shadow
be rowcol  5 21 "Extract files from ZIPfile using PKZIP" bright yellow on green
be rowcol  7 15 "Complete the command line parameters for extraction:" bright white on green
be rowcol  8 15 "   -D  Create Subdirectories" bright white on green
be rowcol  9 15 "   -O  Overwrite Existing Files (Default)" bright white on green
be rowcol 10 15 "   -F  Extract Newer and Existing Files" bright white on green
be rowcol 11 15 "   -N  Extract Newer Files Only" bright white on green
be rowcol 12 15 "   Q   Quit, Return to Main Menu (no extraction)" bright white on green
be rowcol 13 15 " [filespec] Files to extract (Default:  All files)" bright white on green
be window 18 10 20 69 bright white on blue shadow
be rowcol 19 15 "Parameters:  " bright white on blue
be rowcol 19 27
input %%param

if "%@lower[%param%]"=="q" goto redisplay
be window  7 14 14 65 bright white on magenta shadow
be rowcol  9 26 "Extracting files from ZIPfile"

rem Use filename truncation if command won't fit in window
iff %@eval[%@len[%1]+%@len[%param%]] GT 38 then
    set command=PKUNZIP -O %@substr[%1,0,3]...%@substr[%1,%@eval[33-%@len[%param%]],%@eval[%@len[%param%]-32]] %@upper[%param%] %@upper[%param%]
else
    set command=PKUNZIP -O %1 %@upper[%param%]
endiff

be rowcol 11 %@eval[40-(%@len[%command%]/2)] "%command%" bright white on magenta
pkunzip -o %1 %param% > nul
if errorlevel 1 gosub pkerror
goto redisplay

:test
pkunzip -t %1 > nul
iff errorlevel 1 then
    gosub pkerror
else
be window  7 14 14 65 bright white on magenta shadow
be rowcol  9 23 "The ZIPfile passed the integrity check" bright yellow on magenta
be rowcol 12 28 "Press any key to continue" bright white on magenta
pause > nul
goto redisplay

:fix

pause
goto redisplay

:change
be window  3 10 15 69 bright white on green shadow
be rowcol  5 32 "Change Directory" bright yellow on green
be rowcol  6 24 "(using Norton Change Directory)" bright white on green
be rowcol 10 17 "Enter the name of the directory to switch to:" bright white on green

be window 18 10 20 69 bright white on blue shadow
be rowcol 19 15 "Directory:  " bright white on blue
be rowcol 19 27
input %%param

iff "%param%"=="" then
    goto redisplay
else
    ncd %param% > nul
endiff

goto restart

:pkerror
be window  7 14 14 65 bright white on red shadow
be rowcol  9 23 "An error occurred during this step" bright yellow on red
be beep /f200 /d4 /r2
be rowcol 12 28 "Press any key to continue" bright white on red
pause > nul
return

:restart
cls
be window  0  0  24 79 bright white on cyan
goto start

:error
cls
echo An error has occurred in ZIP.BAT
pause

:quit
unset param;command
cls
quit

rem Subroutine to blank out centre windows
:blank
be window 2  1 22 78 cyan on cyan
return

:end
set version=

rem EOF:  ZIP.BAT

